<id>
din1031:AllowedGroupsEmbedFlash
</id>

<version>
1.2.0
</version>

<edit file>
$sourcedir/ManagePosts.php
</edit file>

<search for>
		//Allowed Groups ;) Only numbers and seperator , and ;
		if(!empty($_POST['allowedFlashGroups'])) {
			$_POST['allowedFlashGroups'] = str_replace(array(';', '"', "'"), array(',', '', ''), stripslashes($_POST['allowedFlashGroups']));
			$_POST['allowedFlashGroups'] = explode(',', $_POST['allowedFlashGroups']);
			$new_array = array();
			foreach($_POST['allowedFlashGroups'] as $i) {
				$i = (int) $i;
				if(!empty($i))
					$new_array[$i] = $i;
			}
			$_POST['allowedFlashGroups'] = implode(',', $new_array);
		}
		// Update the actual settings.
		updateSettings(array(
			'removeNestedQuotes' => empty($_POST['removeNestedQuotes']) ? '0' : '1',
</search for>

<replace>
		//Allowed Groups ;)
		if(!empty($_POST['allowedFlashGroups'])) {
			$new_array = array();
			foreach($_POST['allowedFlashGroups'] as $i) {
				$i = (int) $i;
				if(!empty($i))
					$new_array[$i] = $i;
			}
			$_POST['allowedFlashGroups'] = implode(',', $new_array);
		}
		// Update the actual settings.
		updateSettings(array(
			'removeNestedQuotes' => empty($_POST['removeNestedQuotes']) ? '0' : '1',
</replace>

<search for>
	// Check if your PHP is able to use spell checking.
	$context['spellcheck_installed'] = function_exists('pspell_new');
</search for>

<replace>
	//Load membergroups.
	$request = db_query("
		SELECT groupName, ID_GROUP, minPosts
		FROM {$db_prefix}membergroups
		ORDER BY minPosts, ID_GROUP != 1, ID_GROUP != 2, ID_GROUP != 3, groupName", __FILE__, __LINE__);
	while ($row = mysql_fetch_assoc($request))
	{
		$context['groups'][(int) $row['ID_GROUP']] = array(
			'id' => $row['ID_GROUP'],
			'name' => trim($row['groupName']),
			'checked' => in_array($row['ID_GROUP'], explode(',', $modSettings['allowedFlashGroups'])),
			'is_post_group' => $row['minPosts'] != -1,
		);
	}
	mysql_free_result($request);
	//Sorry for the lazyness... but it's easier...
	loadLanguage('ManageBoards');
	
	// Check if your PHP is able to use spell checking.
	$context['spellcheck_installed'] = function_exists('pspell_new');
</replace>

<edit file>
$themedir/Admin.template.php
</edit file>

<search for>
				<td valign="top">
					<input type="checkbox" name="enableEmbeddedFlash" id="enableEmbeddedFlash_check"', empty($modSettings['enableEmbeddedFlash']) ? '' : ' checked="checked"', ' class="check" />
				</td>
			</tr><tr class="windowbg2">
				<th width="50%" align="right">
					<label for="allowedFlashGroups_input">', $txt['allowedFlashGroups'], '</lable> <span style="font-weight: normal;">(<a href="', $scripturl, '?action=helpadmin;help=enableEmbeddedFlash" onclick="return reqWin(this.href);">?</a>)</span>:
					<div class="smalltext" style="font-weight: normal;">', $txt['allowedFlashGroups_info'], '</div>
				</th>
				<td valign="top">
					<input type="text" name="allowedFlashGroups" id="allowedFlashGroups_input" value="', empty($modSettings['allowedFlashGroups']) ? '' : $modSettings['allowedFlashGroups'], '" size="15" />
				</td>
			</tr><tr class="windowbg2">
				<th width="50%" align="right">
					<label for="embededHtmlFlashConvert_check">', $txt['embededHtmlFlashConvert'], '</lable>:
					<div class="smalltext" style="font-weight: normal;">', $txt['embededHtmlFlashConvert_info'], '</div>
				</th>
				<td valign="top">
					<input type="checkbox" name="embededHtmlFlashConvert" id="embededHtmlFlashConvert_check"', empty($modSettings['embededHtmlFlashConvert']) ? '' : ' checked="checked"', ' class="check" />
</search for>

<replace>
				<td valign="top">
					<input type="checkbox" name="enableEmbeddedFlash" id="enableEmbeddedFlash_check"', empty($modSettings['enableEmbeddedFlash']) ? '' : ' checked="checked"', ' class="check" />
				</td>
			</tr><tr class="windowbg2">
				<th width="50%" align="right" valign="top">
					<label for="allowedFlashGroups_input" onclick="return openAllowedFlashGroupList();">', $txt['allowedFlashGroups'], '</lable> <span style="font-weight: normal;">(<a href="', $scripturl, '?action=helpadmin;help=enableEmbeddedFlash" onclick="return reqWin(this.href);">?</a>)</span>:
				</th>
				<td valign="top" align="left"><a href="#" onclick="return openAllowedFlashGroupList();">'.$txt['mboards_groups'].'</a><br />
					<div id="allowedFlashGroupsList" style="display:block;">';

	// List all the membergroups so the user can choose who may access this board.
	foreach ($context['groups'] as $group)
		echo '
						<label for="groups_', $group['id'], '"><input type="checkbox" name="allowedFlashGroups[]" value="', $group['id'], '" id="groups_', $group['id'], '"', $group['checked'] ? ' checked="checked"' : '', ' /> <span', $group['is_post_group'] ? ' style="border-bottom: 1px dotted;" title="' . $txt['mboards_groups_post_group'] . '"' : '', '>', $group['name'], '</span></label><br />';
	echo '
						<input type="checkbox" onclick="invertAll(this, this.form, \'allowedFlashGroups[]\');" /> <i>', $txt[737], '</i><br />
						<br /></div>
	<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
		//This Skript is only for Opening and Closing the group select list
		var allowedFlashGroupListStatus = false;
		
		function openAllowedFlashGroupList() {
			if(allowedFlashGroupListStatus) {
				allowedFlashGroupListStatus = false;
				document.getElementById("allowedFlashGroupsList").style.display = "block";
			}
			else {
				allowedFlashGroupListStatus = true;
				document.getElementById("allowedFlashGroupsList").style.display = "none";
			}
		
			return false;
		}
		
		window.onload=openAllowedFlashGroupList;
	// ]]></script>
						
					</td>
				</tr><tr class="windowbg2">
				<th width="50%" align="right">
					<label for="embededHtmlFlashConvert_check">', $txt['embededHtmlFlashConvert'], '</lable>:
					<div class="smalltext" style="font-weight: normal;">', $txt['embededHtmlFlashConvert_info'], '</div>
				</th>
				<td valign="top">
					<input type="checkbox" name="embededHtmlFlashConvert" id="embededHtmlFlashConvert_check"', empty($modSettings['embededHtmlFlashConvert']) ? '' : ' checked="checked"', ' class="check" />
				</td>
</replace>